<?php
/*
Plugin Name: Bloglines RSS Aggregator Widget 1.0
Description: This WordPress widget displays selected news feeds: (a) searched from bloglines.com, and/or (b) from just about anywhere.  No user account on Bloglines is used, just their search engine. 
			 Once blinesAgg widget is installed, you can configure the widget: Title, and Number of Links to Display;  for Bloglines search service you define: search words to use, and search words to exclude. 
			 Because sometimes there will not be enough titles found within your requested Bloglines search given some combinations of search and avoidance words, you may list extra RSS feeds to be used to fill out 
			 the remaining total number of links to display. That's why I added the extra feeds option, but you may want to skip the Bloglines search feature and just use the extra feeds all by themselves.
			 Bloglines search sometimes returns with several duplicate titles on different sites, the duplicates are identified and skipped (Set $DEbUG true to see the impact on your search).
			 There are several global variables defined at the begining of this widget's source code, use these variables to customize your widget.

Author: Embedded Components, Inc
Version: 1.0.2
Author URI: http://www.embeddedcomponents.com/blogs/2006/11/bloglines-rss-aggregator-widget-10/

File: blinesAgg.php
Last Update: Dec. 2, 2006

Installation within your server:
	Place this php widget file (blinesAgg.php) in your WordPress wp-content/plugins/widgets directory
	Optional Configuration: For speed and reliability we use cURL to read remote web pages, if your server does not support cURL then disable this feature using this global configuration variable below: $USEcURL. The cURL feature includes a timeout parameter, you may want to change this parameter below too: $cURLtIMEOUT
	Optional Performance Improvement: Create a subdirectory for cache storage of feeds with read/write privilege (chmod 777). Then let this widget know about it: activate, define subdirectory, and set cache refresh time using these global configuration variables below: $USEcACHE, $CACHEdIR, and $CACHEtIME 
Configuration within WordPress:	
	Enable the Bloglines RSS aggregator widget plugin from your "administrator -> plugins" menu
	Drag the blinesAgg widget to the sidebar from your "administrator -> presentation -> sidebar widgets" menu
	Configure the BlinesAgg widget with your favorite: title, number of entries to display (maxcount), search words that must appear in a title, and search words that must not be present in a  title
	Because sometimes there will not be enough titles found within Bloglines given some combinations of search words, you may configure extra RSS feeds to be used to fill out the remaining maxcount total number of links
	To skip the Bloglines RSS search feature altogether, and just use the widget as an RSS feed aggregator then just leave the search words configuration entry blank
	Save your changes and visit your WordPress home page to see the list of new found links displayed in your sidebar
	
Thanks:
	I would like to thank the folks at Atomattic for giving us the WordPress Widget along with sample widgets from which I learned how to develop blinesAgg
	I would like to thank Per Sderlind for introducing me to the power of Vojtech Semecky's lastRSS.php object code and how to use it to collect RSS feeds as a WordPress plugin through his blog posts
	
References:
	http://www.bloglines.com/search
	http://automattic.com/code/widgets/
	http://widgets.wordpress.com/	
	http://codex.wordpress.org/Plugins/WordPress_Widgets
	http://lastrss.oslab.net/
	http://www.soderlind.no/
	
License:
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
	
*/

function widget_bloglinesAggrgtr_init() {


	////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// special global variables added to control various features, 11/2006 Ron Fredericks, Embedded Components, Inc.  
	//
	
	global $DEbUG;
	global $USERaGENT;
	global $USEcURL, $cURLtIMEOUT;
	global $SKIPdUPS, $BLINESaNCHR;
	global $USEcACHE, $CACHEdIR, $CACHEtIME;	
	global $INITtITLE, $INITmAXCOUNT, $INITtAGS, $INITnOTAGS, $INITeXTRAFEEDS;	

	
	// $DEbUG 		true: display cache file warnings and errors in widget sidebar during normal operation
	$DEbUG = false;
		
	// $USERaGENT	define cURL or fopen/fgets appearance, use a blank entry ("") to ignore this feature 		
	$USERaGENT = "Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)";		
	
	// $USEcURL 	true: enable cURL instead of fopen/fgets for faster read and timeout control	
	// 				false: use fopen/fgets instead of cURL 
	$USEcURL = true;				
	// $cURLtIMEOUT	if cURL used, define optional page read timeout parameter (in seconds), 20 seems to work well for me
	$cURLtIMEOUT = 20; 


	// $SKIPdUPS	true: check for and remove duplicate consecutive bloglines result titles 
	$SKIPdUPS = true;
	// $BLINESaNCHR	define a named #anchor for referral to Widget Display Title 
	//				example: http://www.embeddedcomponents.com/blogs#blinesAgg when $BLINESaNCHR = blinesAgg;	
	$BLINESaNCHR = 'blinesAgg';

	// $USEcACHE	true: enable the lastRSS cache mechanism (other cache parameters must be installed correctly for this feature to work properly)
	//				Note: you can enable the $DEbUG feature above, temporarily, to verify that cache mechanism is working properly during installation
	$USEcACHE = false;			
	// $CACHEdIR	declare a lastRSS cache directory when set to true, not used if $USEcACHE is set to false
	//				note: using this format, the directory is relative to your WordPress home directory
	$CACHEdIR = './wp-content/plugins/widgets/temp';		
	// $CACHEtIME 	declare number of seconds lastRSS cache remains valid 
	//				example: 3600 will use cached results for one hour before reading rss feeds and updating cache
	$CACHEtIME = 3600;			
	
	// $INIT...		declare initial values for configuration form when fields would otherwise be empty
	$INITtITLE = "Bloglines Aggregator";
	$INITmAXCOUNT =  '10';
	$INITtAGS = array('embedded', 'device');				
	$INITnOTAGS = array('engineer', 'job', 'engr');	
	$INITeXTRAFEEDS = array('http://feeds.feedburner.com/embeddedstar', 'http://slashdot.org/slashdot.rdf');													
			
	//
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	// Check for the required plugin functions. This will prevent fatal
	// errors occurring when you deactivate the dynamic-sidebar plugin.
	if ( !function_exists('register_sidebar_widget') || !function_exists('register_widget_control'))
		return;
		
	// assumes that pc_error_handler function is defined some where
	if ($DEbUG) set_error_handler('pc_error_handler');		

//---------------------------------------------------------------------------------------------------------------
//											lastRSS
//---------------------------------------------------------------------------------------------------------------
	/*
	 lastRSS 0.9.1
	 
	 Simple yet powerful PHP class to parse RSS files.
	 
	 by Vojtech Semecky, webmaster @ webdot . cz
	 
	 Latest version, features, manual and examples:
		http://lastrss.webdot.cz/

	*/
	class lastRSS {
		// -------------------------------------------------------------------
		// Public properties
		// -------------------------------------------------------------------
		var $default_cp = 'UTF-8';
		var $CDATA = 'nochange';
		var $cp = '';
		var $items_limit = 0;
		var $stripHTML = False;
		var $date_format = '';
	
		// -------------------------------------------------------------------
		// Private variables
		// -------------------------------------------------------------------
		var $channeltags = array ('title', 'link', 'description', 'language', 'copyright', 'managingEditor', 'webMaster', 'lastBuildDate', 'rating', 'docs');
		var $itemtags = array('title', 'link', 'description', 'author', 'category', 'comments', 'enclosure', 'guid', 'pubDate', 'source');
		var $imagetags = array('title', 'url', 'link', 'width', 'height');
		var $textinputtags = array('title', 'description', 'name', 'link');
	
		// -------------------------------------------------------------------
		// Parse RSS file and returns associative array.
		// -------------------------------------------------------------------
		function Get ($rss_url) {
			global $DEbUG;
			// If CACHE ENABLED
			if ($this->cache_dir != '') {
				$cache_file = $this->cache_dir . '/rsscache_' . md5($rss_url);
				if (file_exists($cache_file)) {  // avoid access to cache files that don't exist yet: 11/2006 Ron Fredericks, Embedded Components, Inc.
					$timedif = @(time() - filemtime($cache_file));
				} else {
					$timedif = $this->cache_time + 1;
				}
				if ($timedif < $this->cache_time) {
					// cached file is fresh enough, return cached array
					$result = unserialize(join('', file($cache_file)));
					// set 'cached' to 1 only if cached file is correct
					if ($result) $result['cached'] = 1;
				} else {
					// cached file is too old, create new
					$result = $this->Parse($rss_url);
					$serialized = serialize($result);
					if ( $f = @fopen($cache_file, 'w') ) {
						fwrite ($f, $serialized, strlen($serialized));
						fclose($f);
					}
					if ($result) $result['cached'] = 0;
				}
			}
			// If CACHE DISABLED >> load and parse the file directly
			else {
				$result = $this->Parse($rss_url);
				if ($result) $result['cached'] = 0;
			}
			// return result
			if ($result['cached'] == 0 && $DEbUG) echo "<br>debug: cache access not used";
			elseif ($result['cached'] == 1 && $DEbUG) echo "<br>debug: cache was used";
			return $result;
		}
		
		// -------------------------------------------------------------------
		// Modification of preg_match(); return trimmed field with index 1
		// from 'classic' preg_match() array output
		// -------------------------------------------------------------------
		function my_preg_match ($pattern, $subject) {
			// start regular expression
			preg_match($pattern, $subject, $out);
	
			// if there is some result... process it and return it
			if(isset($out[1])) {
				// Process CDATA (if present)
				if ($this->CDATA == 'content') { // Get CDATA content (without CDATA tag)
					$out[1] = strtr($out[1], array('<![CDATA['=>'', ']]>'=>''));
				} elseif ($this->CDATA == 'strip') { // Strip CDATA
					$out[1] = strtr($out[1], array('<![CDATA['=>'', ']]>'=>''));
				}
	
				// If code page is set convert character encoding to required
				if ($this->cp != '')
					//$out[1] = $this->MyConvertEncoding($this->rsscp, $this->cp, $out[1]);
					$out[1] = iconv($this->rsscp, $this->cp.'//TRANSLIT', $out[1]);
				// Return result
				return trim($out[1]);
			} else {
			// if there is NO result, return empty string
				return '';
			}
		}
	
		// -------------------------------------------------------------------
		// Replace HTML entities &something; by real characters
		// -------------------------------------------------------------------
		function unhtmlentities ($string) {
			// Get HTML entities table
			$trans_tbl = get_html_translation_table (HTML_ENTITIES, ENT_QUOTES);
			// Flip keys<==>values
			$trans_tbl = array_flip ($trans_tbl);
			// Add support for &apos; entity (missing in HTML_ENTITIES)
			$trans_tbl += array('&apos;' => "'");
			// Replace entities by values
			return strtr ($string, $trans_tbl);
		}
	
		// -------------------------------------------------------------------
		// Parse() is private method used by Get() to load and parse RSS file.
		// Don't use Parse() in your scripts - use Get($rss_file) instead.
		// -------------------------------------------------------------------
		function Parse ($rss_url) {
			// Open and load RSS file
		
			global $DEbUG;
			global $USERaGENT;
			global $USEcURL, $cURLtIMEOUT;

			if ($USEcURL) {
				// modified lastRSS here to support cURL: Ron Fredericks 11/2006
				$f = curl_init($rss_url);
				curl_setopt($f, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($f, CURLOPT_FOLLOWLOCATION,1);
				curl_setopt($f, CURLOPT_TIMEOUT, $cURLtIMEOUT);
				// let cURL look like a real web browser
				if (trim($USERaGENT!='')) 
					curl_setopt ($f, CURLOPT_USERAGENT, $USERaGENT);	
				$rss_content = curl_exec($f);			
				if (curl_errno($f) && $DEbUG) {			
 					print "<br>Read error on a new link [".$rss_url."]: ".curl_error($f);		
				}
				curl_close($f);
			} 
			else { // !$USEcURL
				// let fgets look like a real web browser, modified from original lastRSS: Ron Fredericks
				if (trim($USERaGENT!='')) 
					ini_set('user_agent', $USERaGENT);
				$f = ( @fopen($rss_url, 'r') );				
				$rss_content = '';
				while (!feof($f)) {
					$rss_content .= fgets($f, 4096);
				}
				fclose($f);
			}
			
			if ($f) {

	
				// Parse document encoding
				$result['encoding'] = $this->my_preg_match("'encoding=[\'\"](.*?)[\'\"]'si", $rss_content);
				// if document codepage is specified, use it
				if ($result['encoding'] != '')
					{ $this->rsscp = $result['encoding']; } // This is used in my_preg_match()
				// otherwise use the default codepage
				else
					{ $this->rsscp = $this->default_cp; } // This is used in my_preg_match()
	
				// Parse CHANNEL info
				preg_match("'<channel.*?>(.*?)</channel>'si", $rss_content, $out_channel);
				foreach($this->channeltags as $channeltag)
				{
					if ( !empty($out_channel[1]) ) {  // test for undefined offset: 11/2006 Ron Fredericks, Embedded Components, Inc.
						$temp = $this->my_preg_match("'<$channeltag.*?>(.*?)</$channeltag>'si", $out_channel[1]);
						if ($temp != '') $result[$channeltag] = $temp; // Set only if not empty
					}
				}
				// If date_format is specified and lastBuildDate is valid
				if ($this->date_format != '' && ($timestamp = strtotime($result['lastBuildDate'])) !==-1) {
							// convert lastBuildDate to specified date format
							$result['lastBuildDate'] = date($this->date_format, $timestamp);
				}
	
				// Parse TEXTINPUT info
				preg_match("'<textinput(|[^>]*[^/])>(.*?)</textinput>'si", $rss_content, $out_textinfo);
					// This a little strange regexp means:
					// Look for tag <textinput> with or without any attributes, but skip truncated version <textinput /> (it's not beginning tag)
				if (isset($out_textinfo[2])) {
					foreach($this->textinputtags as $textinputtag) {
						$temp = $this->my_preg_match("'<$textinputtag.*?>(.*?)</$textinputtag>'si", $out_textinfo[2]);
						if ($temp != '') $result['textinput_'.$textinputtag] = $temp; // Set only if not empty
					}
				}
				// Parse IMAGE info
				preg_match("'<image.*?>(.*?)</image>'si", $rss_content, $out_imageinfo);
				if (isset($out_imageinfo[1])) {
					foreach($this->imagetags as $imagetag) {
						$temp = $this->my_preg_match("'<$imagetag.*?>(.*?)</$imagetag>'si", $out_imageinfo[1]);
						if ($temp != '') $result['image_'.$imagetag] = $temp; // Set only if not empty
					}
				}
				// Parse ITEMS
				preg_match_all("'<item(| .*?)>(.*?)</item>'si", $rss_content, $items);
				$rss_items = $items[2];
				$i = 0;
				$result['items'] = array(); // create array even if there are no items
				foreach($rss_items as $rss_item) {
					// If number of items is lower then limit: Parse one item
					if ($i < $this->items_limit || $this->items_limit == 0) {
						foreach($this->itemtags as $itemtag) {
							$temp = $this->my_preg_match("'<$itemtag.*?>(.*?)</$itemtag>'si", $rss_item);
							if ($temp != '') $result['items'][$i][$itemtag] = $temp; // Set only if not empty
						}
						// Strip HTML tags and other bullshit from DESCRIPTION
						if ($this->stripHTML && $result['items'][$i]['description'])
							$result['items'][$i]['description'] = strip_tags($this->unhtmlentities(strip_tags($result['items'][$i]['description'])));
						// Strip HTML tags and other bullshit from TITLE
						if ($this->stripHTML && $result['items'][$i]['title'])
							$result['items'][$i]['title'] = strip_tags($this->unhtmlentities(strip_tags($result['items'][$i]['title'])));
						// If date_format is specified and pubDate is valid
						if ($this->date_format != '' && ($timestamp = strtotime($result['items'][$i]['pubDate'])) !==-1) {
							// convert pubDate to specified date format
							$result['items'][$i]['pubDate'] = date($this->date_format, $timestamp);
						}
						// Item counter
						$i++;
					}
				}
	
				$result['items_count'] = $i;
				return $result;
			}
			else // Error in opening return False
			{
				return False;
			}
		}
	}
//-------------------------------------------- End of lastRSS Code ----------------------------------------------

//---------------------------------------------------------------------------------------------------------------
//												Widget API
//---------------------------------------------------------------------------------------------------------------
	// This saves options and prints the widget's configuration form.
	function widget_bloglinesAggrgtr_control() {
	
		global $INITtITLE, $INITmAXCOUNT, $INITtAGS, $INITnOTAGS, $INITeXTRAFEEDS;			
	
		$options = $newoptions = get_option('widget_bloglinesAggrgtr');
		if ( $_POST['Bloglines_Aggregator-submit'] ) {
			$newoptions['title'] = strip_tags(stripslashes($_POST['Bloglines_Aggregator-title']));
			$newoptions['count'] = $_POST['Bloglines_Aggregator-count'];
			$newoptions['tags'] = preg_split("/[\s,]+/", strip_tags(stripslashes($_POST['Bloglines_Aggregator-tags'])));
			$newoptions['notags'] = preg_split("/[\s,]+/", strip_tags(stripslashes($_POST['Bloglines_Aggregator-notags'])));
			$newoptions['extrafeeds'] = preg_split("/[\s,]+/", strip_tags(stripslashes($_POST['Bloglines_Aggregator-extrafeeds'])));

		}
		if ( $options != $newoptions ) {
			$options = $newoptions;
			update_option('widget_bloglinesAggrgtr', $options);
		}
		
		// initialize search variables to something useful as a demo for first time users
		// search words for bloglines.com and aggregated extra feeds should not both be blank - or there will be nothing to do
		if ( (trim(wp_specialchars(implode(' ', (array) $options['tags']))) == '') && (trim(wp_specialchars(implode(' ', (array) $options['extrafeeds']))) == '') ) {
			if ( $options['title']=='' )
				$options['title'] = $INITtITLE;
			if ( $options['count']=='' )
				$options['count'] = $INITmAXCOUNT;
			if ( trim(wp_specialchars(implode(' ', (array) $options['tags']))) == '' ) 
				$options['tags'] = $INITtAGS;				
			if ( trim(wp_specialchars(implode(' ', (array) $options['notags']))) == '' ) 
				$options['notags'] = $INITnOTAGS;	
			if ( trim(wp_specialchars(implode(' ', (array) $options['extrafeeds']))) == '' ) 
				$options['extrafeeds'] = $INITeXTRAFEEDS;							
		}				
	?>
				<div style="text-align:right">
				<label for="Bloglines_Aggregator-title" style="line-height:35px;display:block;"><?php _e('Bloglines Aggregator title:', 'widgets'); ?> <input type="text" id="Bloglines_Aggregator-title" name="Bloglines_Aggregator-title" value="<?php echo wp_specialchars($options['title'], true); ?>" /></label>
				<label for="Bloglines_Aggregator-count" style="line-height:35px;display:block;"><?php _e('Number of total links to display:', 'widgets'); ?> <select name="Bloglines_Aggregator-count">   <option value="10" <?php echo ($options['count']=="10") ? 'selected' : ''; ?>>10 Results</option> <option value="20" <?php echo ($options['count']=="20") ? 'selected' : ''; ?>> 20 Results</option> <option value="50" <?php echo ($options['count']=="50") ? 'selected' : ''; ?>>50 Results</option> <option value="100" <?php echo ($options['count']=="100") ? 'selected' : ''; ?>>100 Results</option> </select></label>
				<label for="Bloglines_Aggregator-tags" style="line-height:35px;display:block;"><?php _e('Words for search (separated by space or CR):', 'widgets'); ?> <textarea id="Bloglines_Aggregator-tags" name="Bloglines_Aggregator-tags" style="width:290px;height:40px;"><?php echo wp_specialchars(implode(' ', (array) $options['tags']), true); ?></textarea></label>
				<label for="Bloglines_Aggregator-notags" style="line-height:35px;display:block;"><?php _e("Words to avoid in search (sep by space or CR):", 'widgets'); ?> <textarea id="Bloglines_Aggregator-notags" name="Bloglines_Aggregator-notags" style="width:290px;height:40px;"><?php echo wp_specialchars(implode(' ', (array) $options['notags']), true); ?></textarea></label>
				<label for="Bloglines_Aggregator-extrafeeds" style="line-height:35px;display:block;"><?php _e("Extra RSS or RDF feeds (sep by space or CR):", 'widgets'); ?> <textarea id="Bloglines_Aggregator-extrafeeds" name="Bloglines_Aggregator-extrafeeds" style="width:290px;height:60px;"><?php echo wp_specialchars(implode(' ', (array) $options['extrafeeds']), true); ?></textarea></label>

				<input type="hidden" name="Bloglines_Aggregator-submit" id="Bloglines_Aggregator-submit" value="1" />
				</div>
	<?php
	}
//---------------------------------------------------------------------------------------------------------------
//												Widget Display of Results
//---------------------------------------------------------------------------------------------------------------	

	function widget_bloglinesAggrgtr($args) {
	
		global $DEbUG;
		global $SKIPdUPS, $BLINESaNCHR;
		global $USEcACHE, $CACHEdIR, $CACHEtIME;	


		extract($args);
		
		// Each widget can store its own options. We keep strings here.
		$options = get_option('widget_bloglinesAggrgtr');
		$title = $options['title'];
	?>

			<?php
			//-----------------------------------------------------------------------------------------------------------
			// build Bloglines search string following this example:
			//		'http://www.bloglines.com/search?q=real+time+embedded+device+rtos+-engineer+-job+-engineers+-engr&ql=en&s=f&pop=n&news=m&format=rss'
			//-----------------------------------------------------------------------------------------------------------
			$searchString = 'http://www.bloglines.com/search?q=';
			foreach ($options['tags'] as $tempWord) {
				if ( !empty($tempWord) ) {
					$searchString .= $tempWord.'+';
				}
			}
			$searchString = substr($searchString, 0, -1);
			foreach ($options['notags'] as $tempWord) {
				if ( !empty($tempWord) ) {
					$searchString .= '+-'.$tempWord;
				}
			}
			// language hardcoded to English
			$searchString .= "&ql=en";
			// select search for posts, no limits, date posted anytime, 
			$searchString .= "&s=f";
			// sort by date, filter by popularity = none, 
			//$searchString .= "&pop=n";
			// sort by date, filter by popularity = at least 2 subscribers, 
			//$searchString .= "&pop=l";			
			// sort by date, filter by popularity = many subscribers, 
			$searchString .= "&pop=h";			
			// include news
			$searchString .= "&news=m";
			// select how many entries to get
			$searchString .= "&n=".$options['count'];
			// format as an RSS feed
			$searchString .= "&format=rss";
			$searchRSS = $searchString;
			
			// tack on any extra feeds to use to complete the desired count of links to display
			// examples: 	'http://www.freshfolder.com/rss.php', 'http://feeds.feedburner.com/embeddedstar'
			foreach ($options['extrafeeds'] as $tempWord) {
				$searchString .= ", ".$tempWord;
			}						
			?>
			
			<?php echo $before_widget; ?>
			<?php echo $before_title .'<a name="'.$BLINESaNCHR.'" />'. '<a href="http://www.embeddedcomponents.com/blogs/2006/11/bloglines-rss-aggregator-widget-10/" title="Bloglines aggregator: an open-source WordPress widget developed by Embedded Components, Inc. - named blinesAgg.php" target="_blank">' . $title. '</a>'. $after_title; // . '<a href="'.$searchRSS.'" title="Syndicate this Bloglines aggregator feed using RSS 2.0"><abbr title="Really Simple Syndication" target="_blank"> [RSS]</abbr></a>'  ; ?>
						
			<?php
			//-----------------------------------------------------------------------------------------------------
			// List links starting from RSS URLs 
			//-----------------------------------------------------------------------------------------------------
			$rss_left = explode( ", ", $searchString );
						
			// Create lastRSS object 
			$rss = new lastRSS; 
			
			if ($USEcACHE) {
				// Set cache dir and cache time limit (in seconds) 
				// (don't forget to chmod cache dir to 777 to allow writing) 
				$rss->cache_dir = $CACHEdIR; 
			}
			else {
				$rss->cache_dir = '';
			}
			$rss->cache_time = $CACHEtIME; 
			

			
			// Show all rss files but limited to $maxCount number of links
			$maxCount = ((int) $options['count']);
			$loopCount = 0;
			$loopFlag = true; // sorry folks, this little bit belongs in a Clint Eastwood "spaghetti" Western, but it works to get us out of our foreach() loop(s)
															
			//echo "<table cellpadding=\"2\" border=\"0\"><tr><td width=\"90%\" valign=\"top\">"; 
			foreach ($rss_left as $url) { 
				if (!$loopFlag)
					break;
				if ($rs = $rss->Get($url)) { 
				
					if ( empty($rs['title']) )
						continue;

					if ($loopCount >= $maxCount) {
						// don't print a title if we aren't going to display the results associated with the title.
						$loopFlag = false;
						break;
					}

					if ($loopCount != 0)
						echo "<br />";

					if ( strtolower(substr($rs['title'], 0, 16))== 'bloglines search' ) {
						// custom title for Bloglines search
						echo "<b><a href=\"$rs[link]\" title=\"$rs[description]\" target=\"_blank\">Bloglines Search</a></b><br />\n";
					}
					else {
						// use RSS feed supplied title for extra feeds
						echo "<b><a href=\"$rs[link]\" title=\"$rs[description]\" target=\"_blank\">$rs[title]</a></b><br />\n"; 
					}
					//echo "$rs[description]<br />\n"; 
								
					echo "<ul>\n"; 
					$newTest = array("1", "2"); // initialize consecutive duplicate titles test array
					foreach ($rs['items'] as $item) { 
						$stripTitle = strip_tags(html_entity_decode($item['title']));
						
						// simple test to insure consecutive duplicate titles are not displayed
						if ($SKIPdUPS) {
							$oldTest = $newTest;
							$newTest = explode(" ", $stripTitle);						
							if ( (strcmp($newTest[0],$oldTest[0])===0) && (strlen($newTest[0]) >4) ) {
								if ($DEbUG) echo "<br>debug: skip $newTest[0]";
								continue;
							}
							if ( !empty($newTest[1]) && !empty($oldTest[1]) ) 
								if ( (strcmp($newTest[1],$oldTest[1])===0) ) {
									if ($DEbUG) echo "<br>debug: skip $newTest[0] $newTest[1]";
									continue;
								}
						}
											
						$stripDescription = strip_tags(html_entity_decode($item['description']));					
						$loopCount += 1;
						if ($loopCount > $maxCount) {
							$loopFlag = false;
							break;
						}

						echo "\t<li><a href=\"$item[link]\" title=\"$stripDescription\" target=\"_blank\">$stripTitle</a></li>\n"; 
					} 
					if ($rs['items_count'] <= 0 && $DEbUG ) { 
						echo "<li>debug: Sorry, no items found in the RSS file :-(</li>"; 
					} 
					
					echo "</ul>\n";  
					
				} 
				elseif ($DEbUG) { 
					echo "debug: Sorry, it's not possible to reach RSS file $url\n<br />"; 
					// you will probably hide this message in a live version 
				}  
				
			} 
			
			//echo "</td></tr></table>"; 
			
			
			?> 

		<?php echo $after_widget; ?>
	<?php

	}
	//-----------------------------------------------------------------------------------------------------------
	// Tell Dynamic Sidebar about our new widget and its control
	//-----------------------------------------------------------------------------------------------------------
	register_sidebar_widget(array('blinesAgg', 'widgets'), 'widget_bloglinesAggrgtr');
	register_widget_control(array('blinesAgg', 'widgets'), 'widget_bloglinesAggrgtr_control');
	
}


function pc_error_handler($errno, $error, $file, $line) {
	// assumes that "set_error_handler('pc_error_handler');" exists in main code some where for this handler to be called....
	
	$report_errors = false;
	$pos = strpos($file, 'blinesAgg.php');  // there are so many low level errors reproted with Wordpress itself, limite our reporting to only this widget
	if ($pos)
		$report_errors = true;
			
	if ($report_errors) {
		echo "<br /><font color='red'>debug: we are in pc_error_handler: </font>[ERROR][$errno][$error][$file:$line]";
	}
} // end of pc_error_handler function


// Delay plugin execution to ensure Dynamic Sidebar has a chance to load first
add_action('widgets_init', 'widget_bloglinesAggrgtr_init');
?>
